hdu 1258(深搜)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1258

Sum It Up

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 4012    Accepted Submission(s): 2066

Problem Description

Given a specified total t and a list of n integers, find all distinct sums using numbers from the list that add up to t. For example, if t=4, n=6, and the list is [4,3,2,2,1,1], then there are four different sums that equal 4: 4,3+1,2+2,
and 2+1+1.(A number can be used within a sum as many times as it appears in the list, and a single number counts as a sum.) Your job is to solve this problem in general.

Input

The input will contain one or more test cases, one per line. Each test case contains t, the total, followed by n, the number of integers in the list, followed by n integers x1,...,xn. If n=0 it signals the end of the input; otherwise,
t will be a positive integer less than 1000, n will be an integer between 1 and 12(inclusive), and x1,...,xn will be positive integers less than 100. All numbers will be separated by exactly one space. The numbers in each list appear in nonincreasing order,
and there may be repetitions.

Output

For each test case, first output a line containing ‘Sums of‘, the total, and a colon. Then output each sum, one per line; if there are no sums, output the line ‘NONE‘. The numbers within each sum must appear in nonincreasing order.
A number may be repeated in the sum as many times as it was repeated in the original list. The sums themselves must be sorted in decreasing order based on the numbers appearing in the sum. In other words, the sums must be sorted by their first number; sums
with the same first number must be sorted by their second number; sums with the same first two numbers must be sorted by their third number; and so on. Within each test case, all sums must be distince; the same sum connot appear twice.

Sample Input

4 6 4 3 2 2 1 1
5 3 2 1 1
400 12 50 50 50 50 50 50 25 25 25 25 25 25
0 0

Sample Output

Sums of 4:
4
3+1
2+2
2+1+1
Sums of 5:
NONE
Sums of 400:
50+50+50+50+50+50+25+25+25+25
50+50+50+50+50+25+25+25+25+25+25

题意:  首先给你一个t,一个n;紧接着n个数,问这n个数有多少种加和方式使得加和结果等于t;并且注意不能重复~比如 4=3+1,那么多个4=3+1只能算一种,4=1+3也是一种;

思路:从大到小排序~深搜AC;

#include <iostream>
#include <string.h>
#include <string>
#include <stdio.h>
#include <cmath>
#include <cstdio>
#include <algorithm>
using namespace std;
int t,n,flag;
int a[16],queue[16];//模拟队列

int cmp(int a,int b)
{
    return a>b;
}

void dfs(int sum,int count,int pos)
{
    if(sum>t)return; //递归出口(目标检测函数)
    if(sum==t)
    {
        flag=1;
        for(int i=0;i<count-1;i++)
            printf("%d+",queue[i]);
        printf("%d\n",queue[count-1]);
        return;
    }
    for(int i=pos;i<n;i++)//将一种状态转化为另一种状态的操作结合
    {
        sum+=a[i];
        queue[count]=a[i];
        dfs(sum,count+1,i+1);
        sum-=a[i];
        while(a[i]==a[i+1])i++; //这是为了避免重复
    }
}

int main()
{
        while(cin>>t>>n)
        {
            if(t==0&&n==0)break;
            for(int i=0;i<n;i++)
            {
               cin>>a[i];
            }
            sort(a,a+n,cmp);
            flag=0;
            cout<<"Sums of "<<t<<":"<<endl;
            dfs(0,0,0); //初始状态集合
            if(!flag)
                cout<<"NONE"<<endl;

        }
        return 0;
}
时间: 2024-08-06 20:06:05

hdu 1258(深搜)的相关文章

HDU 2717 深搜第一题、

题意:求n到k的最小路径,  n有三种变法 n+1,n-1或者2*n: 贴个广搜的模版在这里把.... 总结一下:一般涉及到求最短路的话用深搜 1 #include<iostream> 2 #include<cstdio> 3 #include<algorithm> 4 #include<queue> 5 #include<cstring> 6 using namespace std; 7 const int qq=1e5+10; 8 int v

HDU 3720 深搜 枚举

DES:从23个队员中选出4—4—2—1共4种11人来组成比赛队伍.给出每个人对每个职位的能力值.给出m组人在一起时会产生的附加效果.问你整场比赛人员的能力和最高是多少. 用深搜暴力枚举每种类型的人选择情况.感觉是这个深搜写的很机智. 在vector中存结构体就会很慢.TLE.直接存序号就AC了.以后还是尽量少用结构体吧. #include<stdio.h> #include<string.h> #include<map> #include<vector>

HDU 1010 深搜+减枝

HDU 1010 /************************************************************************* > File Name: HDU1010.cpp > Author:yuan > Mail: > Created Time: 2014年11月05日 星期三 22时22分56秒 **********************************************************************

HDU 1010 深搜+奇偶剪枝

题目:http://acm.hdu.edu.cn/showproblem.php?pid=1010 贴个资料: http://acm.hdu.edu.cn/forum/read.php?tid=6158 奇偶剪枝: 对于从起始点 s 到达终点 e,走且只走 t 步的可达性问题的一种剪枝策略. 如下列矩阵 : 从任意 0 到达 任意 0,所需步数均为偶数,到达任意 1 ,均为奇数.反之亦然 所以有,若s走且只走 t 步可到达e,则必有t >= abs(s.x - e.x) + abs(s.y -

hdu 1010 深搜+剪枝

深度搜索 剪枝 还不是很理解 贴上众神代码 //http://blog.csdn.net/vsooda/article/details/7884772#include<iostream> #include<math.h> using namespace std; char map[10][10]; int N,M,T; int di,dj,escape; int dir[4][2]={{0,-1},{0,1},{1,0},{-1,0}}; void dfs(int x,int y,

hdu 1204 深搜

#include <iostream> #include <string> #define MAX 110 #define OIL true #define BLANK false using namespace std; bool oil_map[MAX][MAX]; int dir_map[8][2]={ {1,0},{-1,0},{0,1},{0,-1},{1,1},{1,-1},{-1,1},{-1,-1} }; void set_oil_map() { memset(oi

HDU 1258 Sum It Up 深搜

 Crawling in process... Crawling failed   Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1258 Description Given a specified total t and a list of n integers, find all distinct sums using numb

【深搜加剪枝五】HDU 1010 Tempter of the Bone

Tempter of the BoneTime Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 64326    Accepted Submission(s): 17567 Problem Description The doggie found a bone in an ancient maze, which fascinated him a l

深搜基础题目 杭电 HDU 1241

HDU 1241 是深搜算法的入门题目,递归实现. 原题目传送门: http://acm.hdu.edu.cn/showproblem.php?pid=1241 代码仅供参考,c++实现: #include <iostream> using namespace std; char land[150][150]; int p,q; void dfs(int x,int y){ land[x][y] = '*'; if(land[x-1][y]!= '@' && land[x+1]